VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CGenreList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private maxGenres As Byte

Private genrearr() As String

Public Sub read(ByVal pn As String)

    Dim num As Integer
    Dim count As Byte
    
    On Error GoTo error
    
    num = FreeFile()
    
    Open pn For Input Access Read Lock Read As num
    'read number of entries
    Input #num, maxGenres
    ReDim genrearr(0 To maxGenres - 1)
    
    For count = 0 To maxGenres - 1
        Input #num, genrearr(count)
    Next count
    
    Close num
    
    Exit Sub

error:
    Select Case ErrCategory(Err.Number)
    Case ErrCatMath, ErrCatMisc, ErrCatIllegal
        MsgBox "Undefined error #" & Err.Number & ". Please contact the author with information about " & _
            "this error and what caused it.", vbCritical
        Resume Nums
    Case ErrCatFile
        Select Case Err.Number
        Case ErrPathNotExist, ErrPathFileAccessError, ErrFileNotFound
            Select Case MsgBox("Genre file " & pn & " not found. Numbers will " & _
                "be used instead. Specify genre file using Edit/Options...", vbExclamation And vbRetryCancel, _
                "Error while opening genre list")
            Case vbRetry
                Resume
            Case vbCancel
                Resume Nums
            End Select
        Case Else
            Select Case FileError(Err.Number, "Error while opening genre list", pn)
            Case vbRetry
                Resume
            Case vbCancel
                Resume Nums
            End Select
        End Select
    End Select

Nums:
    maxGenres = 254
    ReDim genrearr(0 To 254)
    For count = 0 To 254
        genrearr(count) = count
    Next count

End Sub

Public Function num2string(ByVal num As Byte) As String
    If num < 0 Or num >= maxGenres Then
        num2string = ""
    Else
        num2string = genrearr(num)
    End If
    'returns "" if index out of bounds
End Function

Public Function string2num(ByVal ins As String) As Byte
    Dim count As Byte
    Dim res As Byte
    
    res = 255
    For count = 0 To maxGenres - 1
        If genrearr(count) = ins Then
            res = count
            Exit For
        End If
    Next count
    
    string2num = res
    'returns 255 if genre not found
End Function
