VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ID3Tag"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Variablen

'Private id3Title As String * 30
Private id3Title As String
'Private id3Artist As String * 30
Private id3Artist As String
Private id3Album As String * 30
Private id3Comment As String * 28
Private id3Year As String * 4
Private id3Genre As Byte
Private id3Track As Byte
Private mp3Type As Single
Private mp3Bitrate As Integer
Private mp3Sample As Single
Private mp3Length As String
Private mp3Mono As Integer '-1 n/a 0 mono 1 stereo 2 joint stereo 3 dual channel
Private mp3VBR As Boolean


' Schnittstellen

' TODO: Bereichsprfung bei Let

Public Property Get Title() As String
  Title = id3Title
End Property

Public Property Let Title(ByVal n As String)
    id3Title = n
End Property

Public Property Get Artist() As String
  Artist = id3Artist
End Property

Public Property Let Artist(ByVal A As String)
    id3Artist = A
End Property

Public Property Get Album() As String
    Album = id3Album
End Property

Public Property Let Album(ByVal A As String)
    id3Album = String(30, " ")
    id3Album = cutTag(A, 30)
End Property

Public Property Get Comment() As String
  Comment = id3Comment
End Property

Public Property Let Comment(ByVal c As String)
    id3Comment = String(30, " ")
    id3Comment = cutTag(c, 30)
End Property

Public Property Get Year() As String
    Year = id3Year
End Property

Public Property Let Year(ByVal Y As String)
    id3Year = String(4, " ")
    id3Year = cutTag(Y, 4)
End Property

Public Property Get genre() As Byte
  genre = id3Genre
End Property

Public Property Let genre(ByVal g As Byte)
  id3Genre = g
End Property

Public Property Get track() As Byte
  track = id3Track
End Property

Public Property Let track(ByVal g As Byte)
  id3Track = g
End Property

Public Property Get typ() As Single
    typ = mp3Type
End Property

Public Property Get bitrate() As Integer
    bitrate = mp3Bitrate
End Property

Public Property Get sample() As String
    Dim s As String
    
    s = CStr(mp3Sample)
    If InStr(1, s, ",") Then
        s = Left(s, InStr(1, s, ",") - 1) & "." & Mid(s, InStr(1, s, ",") + 1)
    End If
    sample = s
End Property

Public Property Get length() As String
    length = mp3Length
End Property

Public Property Get mono() As Integer
    mono = mp3Mono
End Property

Public Property Get vbr() As Boolean
    vbr = mp3VBR
End Property


' Methoden

Public Sub readTag(ByVal pn As String)
  
    Dim num As Integer
    Dim pos As Long
    Dim fl As Long
    Dim tag As String * 3
    Dim b As Byte, back As Byte
    Dim opened As Boolean
    Dim opt As New COptions
    Dim riffstr As String * 4
    Dim offset As Integer
    Dim vbrFlags As Currency
    Dim vbrFrames As Currency
    Dim vbrBytes As Currency
    Dim dummy As Byte
    
    opt.readOptions
    clearId3
    
    On Error GoTo error
    opened = False
    
    num = FreeFile()
    Open pn For Binary Access Read As num
    opened = True
  
    offset = findSync(num, 1)
    If offset = -1 Then
        MsgBox "File " & pn & " does not contain at least one mp3 frame", vbExclamation + vbOK, "Reading ID3 tag"
        Close #num
    End If
    
    'read mp3 info
    
    'read type (1, 2, 2.5)
    mp3Type = readType(num, offset)
    
    'read mono/stereo
    mp3Mono = readMono(num, offset, mp3Type, opt, pn)
      
    'read sampling frequency
    mp3Sample = readSamplerate(num, offset, mp3Type, opt, pn)
    
    'check if file is VBR
    mp3VBR = checkVBR(num, offset, mp3Type, mp3Mono)
    
    fl = LOF(num)
    If mp3VBR Then
        vbrFlags = readVBRFlags(num, offset, mp3Type, mp3Mono)
        If (vbrFlags And 3) <> 3 Then
            'frames and bytes fields must be present
            mp3Bitrate = 0
            mp3Length = 0
        Else
            vbrFrames = readVBRFrames(num, offset, mp3Type, mp3Mono)
            vbrBytes = readVBRBytes(num, offset, mp3Type, mp3Mono)
            mp3Bitrate = CInt(vbrBytes * mp3Sample / vbrFrames / 144)
            mp3Length = CInt(vbrFrames * 144 * 8 / mp3Sample / 1000)
        End If
    Else
        'bitrate
        mp3Bitrate = readBitrate(num, offset, mp3Type, opt, pn)
    
        'length
        If fl > 0 And mp3Bitrate > -1 Then
            mp3Length = CInt(fl / (125 * mp3Bitrate))
        Else
            mp3Length = 0
        End If
    End If
    
    'tag
    If fl < 127 Then
        Close num
        Exit Sub
    End If
    pos = fl - 127
    Get #num, pos, tag
    If tag <> "TAG" Then
        Close num
        Exit Sub
    End If
    pos = pos + 3
    Get #num, pos, id3Title
    Get #num, pos + 30, id3Artist
    Get #num, pos + 60, id3Album
    Get #num, pos + 90, id3Year
    Get #num, pos + 94, id3Comment
    Get #num, pos + 122, dummy
    'if this is not null, tag is ID3v1.0 (no track field)
    If dummy <> 0 Then
        id3Track = 0
    Else
        Get #num, pos + 123, id3Track
    End If
    Get #num, pos + 124, id3Genre
    Close #num

    Exit Sub

error:
    Select Case ErrCategory(Err.Number)
    Case ErrCatMisc
        If Err.Number = ErrCancel Then
            Exit Sub
        End If
    Case ErrCatFile
        Select Case FileError(Err.Number, "Reading ID3 tag", pn)
        Case vbRetry
            Resume
        Case vbCancel
            If opened Then
                Close #num
            End If
            Exit Sub
        End Select
    Case Else
        Select Case MiscError(Err.Number, "Reading ID3 tag")
        Case vbRetry
            Resume
        Case vbCancel
            If opened Then
                Close #num
            End If
            Exit Sub
        End Select
    End Select
End Sub

Public Sub writeTag(ByVal pn As String)
    
    Dim num As Integer
    Dim pos As Long
    Dim fl As Long
    Dim tag As String * 3
    Dim opened As Boolean
    Dim opt As New COptions
    Dim readonly As Boolean
    Dim attr As Integer
    Dim bnull As Byte 'to write \0 after comment
    
    On Error GoTo error
    opened = False
    readonly = False
    
    num = FreeFile()
    Open pn For Binary Access Read Write As num
    opened = True
    
    fl = LOF(num)
    If fl < 127 Then
        createNewTag (num)
        pos = LOF(num) + 1
    Else
        pos = fl - 127
        Get #num, pos, tag
        If tag <> "TAG" Then
            createNewTag (num)
            pos = LOF(num) + 1
        Else
            pos = pos + 3
        End If
    End If
    
    Dim ttitle As String * 30
    Dim tartist As String * 30
    ttitle = cutTag(id3Title, 30)
    tartist = cutTag(id3Artist, 30)
    Put #num, pos, spaceToNull(ttitle)
    Put #num, , spaceToNull(tartist)
    Put #num, , spaceToNull(id3Album)
    Put #num, , spaceToNull(id3Year)
    Put #num, , spaceToNull(id3Comment)
    bnull = 0
    Put #num, , bnull
    Put #num, , id3Track
    Put #num, , id3Genre
    Close #num
    
    If readonly Then
        SetAttr pn, attr
    End If
    
    Exit Sub
        
error:
    Select Case ErrCategory(Err.Number)
    Case ErrCatMisc
        If Err.Number = ErrCancel Then
            Exit Sub
        End If
    Case ErrCatFile
        Select Case Err.Number
        Case ErrPathFileAccessError
            opt.readOptions
            If opt.AskReadOnly Then
                Select Case MsgBox("File " & pn & " is read-only. OK to write anyway?", vbExclamation + vbOKCancel, "Writing ID3 tag")
                Case vbOK
                    readonly = True
                    attr = GetAttr(pn)
                    SetAttr pn, vbNormal
                    Resume
                Case vbCancel
                    If opened Then
                        Close #num
                    End If
                    Exit Sub
                End Select
            Else
                readonly = True
                attr = GetAttr(pn)
                SetAttr pn, vbNormal
                Resume
            End If
        Case Else
            Select Case FileError(Err.Number, "Writing ID3 tag", pn)
            Case vbRetry
                Resume
            Case vbCancel
                If opened Then
                    Close #num
                End If
                Exit Sub
            End Select
        End Select
    Case Else
        Select Case MiscError(Err.Number, "Writing ID3 tag")
        Case vbRetry
            Resume
        Case vbCancel
            If opened Then
                Close #num
            End If
            Exit Sub
        End Select
    End Select

End Sub

Public Sub removeTag(ByVal pn As String)
    
    Dim num As Integer
    Dim pos As Long
    Dim fl As Long
    Dim tag As String * 3
    Dim opened As Boolean
    Dim opt As New COptions
    Dim readonly As Boolean
    Dim attr As Integer
    
    On Error GoTo error
    opened = False
    readonly = False
    
    num = FreeFile()
    Open pn For Binary Access Read Write As num
    opened = True
    
    fl = LOF(num)
    If fl < 127 Then
        createNewTag (num)
        pos = LOF(num) + 1
    Else
        pos = fl - 127
        Get #num, pos, tag
        If tag <> "TAG" Then
            createNewTag (num)
            pos = LOF(num) + 1
        Else
            pos = pos + 3
        End If
    End If
    
    Put #num, pos, id3Title
    Put #num, , id3Artist
    Put #num, , id3Album
    Put #num, , id3Year
    Put #num, , id3Comment
    Put #num, , id3Genre
    Close #num
    
    If readonly Then
        SetAttr pn, attr
    End If
    
    Exit Sub
        
error:
    Select Case ErrCategory(Err.Number)
    Case ErrCatMisc
        If Err.Number = ErrCancel Then
            Exit Sub
        End If
    Case ErrCatFile
        Select Case Err.Number
        Case ErrPathFileAccessError
            opt.readOptions
            If opt.AskReadOnly Then
                Select Case MsgBox("File " & pn & " is read-only. OK to write anyway?", vbExclamation + vbOKCancel, "Writing ID3 tag")
                Case vbOK
                    readonly = True
                    attr = GetAttr(pn)
                    SetAttr pn, vbNormal
                    Resume
                Case vbCancel
                    If opened Then
                        Close #num
                    End If
                    Exit Sub
                End Select
            Else
                readonly = True
                attr = GetAttr(pn)
                SetAttr pn, vbNormal
                Resume
            End If
        Case Else
            Select Case FileError(Err.Number, "Writing ID3 tag", pn)
            Case vbRetry
                Resume
            Case vbCancel
                If opened Then
                    Close #num
                End If
                Exit Sub
            End Select
        End Select
    Case Else
        Select Case MiscError(Err.Number, "Writing ID3 tag")
        Case vbRetry
            Resume
        Case vbCancel
            If opened Then
                Close #num
            End If
            Exit Sub
        End Select
    End Select

End Sub

Public Sub ConvertFilename(ByVal fn As String, ByVal pn As String)
    Dim opt As New COptions
    Dim nextpos As Integer
    Dim tno As Boolean
    Const blank30 = "                              "
    
    opt.readOptions
    readTag pn
    
    'select which pattern to apply
    If opt.RecognizeRoundPar And (Mid(fn, 1, 1) = "(" Or Mid(fn, 4, 1) = "(") And InStr(2, fn, ")-") > 0 Then
        '(artist)-title.mp3
        'track no first?
        If IsNumeric(Mid(fn, 1, 2)) Then
            If opt.FillOnlyEmpty = False Or id3Comment = blank30 Then
                id3Comment = "Track " & Mid(fn, 1, 2)
            End If
            nextpos = 4
            tno = True
        Else
            nextpos = 1
            tno = False
        End If
        'get artist
        If opt.FillOnlyEmpty = False Or id3Artist = "" Then
            id3Artist = Mid(fn, nextpos + 1, InStr(nextpos + 2, fn, ")-") - nextpos - 1)
        End If
        nextpos = InStr(nextpos + 2, fn, ")-") + 2
        'get track no
        If Not tno Then
            If IsNumeric(Mid(fn, nextpos, 2)) Then
                If opt.FillOnlyEmpty = False Or id3Comment = blank30 Then
                    id3Comment = "Track " & Mid(fn, nextpos, 2)
                End If
                nextpos = nextpos + 3
            End If
        End If
        If opt.FillOnlyEmpty = False Or id3Title = "" Then
            id3Title = Mid(fn, nextpos, InStr(nextpos, fn, ".mp3", vbTextCompare) - nextpos)
        End If
        
    ElseIf opt.RecognizeSquarePar And (Mid(fn, 1, 1) = "[" Or Mid(fn, 4, 1) = "[") And InStr(2, fn, "]-") > 0 Then
        '[artist]-title.mp3
        'track no first?
        If IsNumeric(Mid(fn, 1, 2)) Then
            If opt.FillOnlyEmpty = False Or id3Comment = blank30 Then
                id3Comment = "Track " & Mid(fn, 1, 2)
            End If
            nextpos = 4
            tno = True
        Else
            nextpos = 1
            tno = False
        End If
        'get artist
        If opt.FillOnlyEmpty = False Or id3Artist = "" Then
            id3Artist = Mid(fn, nextpos + 1, InStr(nextpos + 2, fn, "]-") - nextpos - 1)
        End If
        nextpos = InStr(nextpos + 2, fn, "]-") + 2
        'get track no
        If Not tno Then
            If IsNumeric(Mid(fn, nextpos, 2)) Then
                If opt.FillOnlyEmpty = False Or id3Comment = blank30 Then
                    id3Comment = "Track " & Mid(fn, nextpos, 2)
                End If
                nextpos = nextpos + 3
            End If
        End If
        If opt.FillOnlyEmpty = False Or id3Title = "" Then
            id3Title = Mid(fn, nextpos, InStr(nextpos, fn, ".mp3", vbTextCompare) - nextpos)
        End If
    
    ElseIf opt.RecognizeSpace And (InStr(2, fn, " - ") > 0 Or (InStr(2, fn, " -") > 0 And InStr(2, fn, "- ") > 0)) Then
        'artist - title.mp3
        'track no first?
        If IsNumeric(Mid(fn, 1, 2)) Then
            If opt.FillOnlyEmpty = False Or id3Comment = blank30 Then
                id3Comment = "Track " & Mid(fn, 1, 2)
            End If
            If Mid(fn, 3, 3) = " - " Then
                nextpos = 6
            Else
                nextpos = 4
            End If
            tno = True
        Else
            nextpos = 1
            tno = False
        End If
        'artist?
        If InStr(nextpos, fn, " - ") > 0 Or (InStr(nextpos, fn, " -") > 0 And InStr(nextpos, fn, "- ") > 0) Then
            'get artist
            Dim pos As Integer
            If InStr(nextpos, fn, " - ") > 0 Then
                pos = InStr(nextpos, fn, " - ")
            Else
                pos = InStr(nextpos, fn, " -")
            End If
            If opt.FillOnlyEmpty = False Or id3Artist = "" Then
                id3Artist = Mid(fn, nextpos, pos - nextpos)
            End If
            nextpos = pos + 2
            If Mid(fn, nextpos, 1) = " " Then nextpos = nextpos + 1
        End If
        'get track no
        If Not tno Then
            If IsNumeric(Mid(fn, nextpos, 2)) Then
                If opt.FillOnlyEmpty = False Or id3Comment = blank30 Then
                    id3Comment = "Track " & Mid(fn, nextpos, 2)
                End If
                nextpos = InStr(nextpos, fn, "- ") + 2
            End If
        End If
        'get title
        If opt.FillOnlyEmpty = False Or id3Title = "" Then
            id3Title = Mid(fn, nextpos, InStr(nextpos, fn, ".mp3", vbTextCompare) - nextpos)
        End If
        
    ElseIf opt.RecognizeSquareSpace And (Mid(fn, 1, 2) = "[ " Or Mid(fn, 4, 2) = "[ ") And InStr(3, fn, "] ") > 0 Then
        '[ artist ] title.mp3
        If IsNumeric(Mid(fn, 1, 2)) Then
            If opt.FillOnlyEmpty = False Or id3Comment = blank30 Then
                id3Comment = "Track " & Mid(fn, 1, 2)
            End If
            nextpos = 6
            tno = True
        Else
            nextpos = 3
            tno = False
        End If
        'get artist
        If opt.FillOnlyEmpty = False Or id3Artist = "" Then
            id3Artist = Mid(fn, nextpos, InStr(nextpos, fn, " ] ") - nextpos)
        End If
        nextpos = InStr(nextpos, fn, " ] ") + 3
        'get track no
        If Not tno Then
            If IsNumeric(Mid(fn, nextpos, 2)) Then
                If opt.FillOnlyEmpty = False Or id3Comment = blank30 Then
                    id3Comment = "Track " & Mid(fn, nextpos, 2)
                End If
                nextpos = nextpos + 3
            End If
        End If
        'get title
        If opt.FillOnlyEmpty = False Or id3Title = "" Then
            id3Title = Mid(fn, nextpos, InStr(nextpos, fn, ".mp3", vbTextCompare) - nextpos)
        End If

    ElseIf opt.RecognizeIntelligent Then
        'try to get as much information as possible
        
        'check if name contains track number
        Dim i As Integer
        Dim setTNo As Boolean
        Dim setTit As Boolean
        Dim setArt As Boolean
        setTNo = False
        setTit = False
        setArt = False
        nextpos = 1
        For i = 1 To Len(fn) - 1
            If IsNumeric(Mid(fn, i, 2)) Then
                'track no found
                tno = True
                If opt.FillOnlyEmpty = False Or id3Comment = blank30 Then
                    id3Comment = "Track " & Mid(fn, i, 2)
                    setTNo = True
                End If
                nextpos = i + 1
                Exit For
            End If
        Next i
        
        'try to find artist
        If InStr(1, fn, "(") > 0 And InStr(1, fn, ")") > 0 Then
            If opt.FillOnlyEmpty = False Or id3Artist = "" Then
                id3Artist = Mid(fn, InStr(1, fn, "(") + 1, InStr(1, fn, ")") - InStr(1, fn, "("))
                setArt = True
            End If
            If InStr(1, fn, ")") + 1 > nextpos Then
                nextpos = InStr(1, fn, ")") + 1
            End If
        ElseIf InStr(1, fn, "[") > 0 And InStr(1, fn, "]") > 0 Then
            If opt.FillOnlyEmpty = False Or id3Artist = "" Then
                id3Artist = Mid(fn, InStr(1, fn, "[") + 1, InStr(1, fn, ")") - InStr(1, fn, "]"))
                setArt = True
            End If
            If InStr(1, fn, "]") + 1 > nextpos Then
                nextpos = InStr(1, fn, "]") + 1
            End If
        ElseIf InStr(1, fn, "-") > 0 Then
            If opt.FillOnlyEmpty = False Or id3Artist = "" Then
                id3Artist = Mid(fn, 1, InStr(1, fn, "-"))
                setArt = True
            End If
            If InStr(1, fn, "-") + 1 > nextpos Then
                nextpos = InStr(1, fn, "-") + 1
            End If
        End If
        If opt.FillOnlyEmpty = False Or id3Title = "" Then
            id3Title = Mid(fn, nextpos, InStr(nextpos, fn, ".mp3", vbTextCompare) - nextpos)
            setTit = True
        End If
        
        If setTit Then
            id3Title = killBeginningSpace(killSpace(id3Title))
            If Left(id3Title, 1) = "-" Then
                id3Title = Mid(id3Title, 2)
            End If
        End If
        If setArt Then
            id3Artist = killBeginningSpace(killSpace(id3Artist))
            If Left(id3Artist, 1) = "-" Then
                id3Artist = Mid(id3Artist, 2)
            End If
        End If
    
    End If
End Sub

Public Function ConvertToFilename(ByVal t As String, ByVal ar As String, _
                                  ByVal c As String, ByVal comm As String) As String
    
    Dim dum As Integer
    Dim art As String
    Dim tit As String
    Dim com As String
    Dim track As String
    Dim opt As New COptions
    
    opt.readOptions
    
    If ar <> "" Then
        art = ar
    Else
        art = killSpace(id3Artist)
    End If
    If opt.Lowercase Then art = LCase(art)
    If t <> "" Then
        tit = t
    Else
        tit = killSpace(id3Title)
    End If
    If opt.Lowercase Then tit = LCase(tit)
    If c <> "" Then
        c = killSpace(c)
    Else
        c = killSpace(id3Track)
    End If
    If comm <> "" Then
        comm = killSpace(comm)
    Else
        comm = killSpace(id3Comment)
    End If
    If c <> "" And c <> "0" Then
        If Len(c) = 1 Then
            track = "0" & c & "-"
        Else
            track = c & "-"
        End If
    Else
        If Left(comm, 6) = "Track " Then
            comm = Mid(comm, 7)
        End If
        If IsNumeric(comm) Then
            If comm <> "" And comm <> "0" Then
                If Len(comm) = 1 Then
                    track = "0" & comm & "-"
                Else
                    track = comm & "-"
                End If
            End If
        Else
            track = ""
        End If
    End If
    
    Dim offset '0 normal, 3 bzw. 4 wenn Tracknummer in Filenamen soll
    If opt.TrackNo = 0 Then
        offset = 0
    ElseIf opt.TrackNo = 1 Then
        offset = 4
    Else
        offset = 3
    End If
    
    If opt.ConvertToRoundPar Then
        If Len(art) + Len(tit) + 7 + offset > 60 Then
            dum = 60 - (Len(art) + 7 + offset)
            If dum < 0 Then
                dum = 60 - (Len(tit) + 7 + offset)
                If opt.TrackNo = 0 Then
                    ConvertToFilename = "(" & SpaceToUnderscore(Left(art, dum)) & ")-" _
                                        & SpaceToUnderscore(tit) & ".mp3"
                ElseIf opt.TrackNo = 1 Then
                    ConvertToFilename = "(" & SpaceToUnderscore(Left(art, dum)) & ")-" _
                                        & track & SpaceToUnderscore(tit) & ".mp3"
                Else
                    ConvertToFilename = track & "(" & SpaceToUnderscore(Left(art, dum)) & ")-" _
                                        & SpaceToUnderscore(tit) & ".mp3"
                End If
            Else
                If opt.TrackNo = 0 Then
                    ConvertToFilename = "(" & SpaceToUnderscore(art) & ")-" _
                                        & SpaceToUnderscore(Left(tit, dum)) & ".mp3"
                ElseIf opt.TrackNo = 1 Then
                    ConvertToFilename = "(" & SpaceToUnderscore(art) & ")-" & track _
                                        & SpaceToUnderscore(Left(tit, dum)) & ".mp3"
                Else
                    ConvertToFilename = track & "(" & SpaceToUnderscore(art) & ")-" & _
                                        SpaceToUnderscore(Left(tit, dum)) & ".mp3"
                End If
            End If
        Else
            If opt.TrackNo = 0 Then
                ConvertToFilename = "(" & SpaceToUnderscore(art) & ")-" _
                    & SpaceToUnderscore(tit) & ".mp3"
            ElseIf opt.TrackNo = 1 Then
                ConvertToFilename = "(" & SpaceToUnderscore(art) & ")-" _
                    & track & SpaceToUnderscore(tit) & ".mp3"
            Else
                ConvertToFilename = track & "(" & SpaceToUnderscore(art) & ")-" _
                    & SpaceToUnderscore(tit) & ".mp3"
            End If
        End If
    ElseIf opt.ConvertToSquarePar Then
        If Len(art) + Len(tit) + 7 + offset > 60 Then
            dum = 60 - (Len(art) + 7 + offset)
            If dum < 0 Then
                dum = 60 - (Len(tit) + 7 + offset)
                If opt.TrackNo = 0 Then
                    ConvertToFilename = "[" & SpaceToUnderscore(Left(art, dum)) & "]-" _
                                        & SpaceToUnderscore(tit) & ".mp3"
                ElseIf opt.TrackNo = 1 Then
                    ConvertToFilename = "[" & SpaceToUnderscore(Left(art, dum)) & "]-" _
                                        & track & SpaceToUnderscore(tit) & ".mp3"
                Else
                    ConvertToFilename = track & "[" & SpaceToUnderscore(Left(art, dum)) & "]-" _
                                        & SpaceToUnderscore(tit) & ".mp3"
                End If
            Else
                If opt.TrackNo = 0 Then
                    ConvertToFilename = "[" & SpaceToUnderscore(art) & "]-" _
                                        & SpaceToUnderscore(Left(tit, dum)) & ".mp3"
                ElseIf opt.TrackNo = 1 Then
                    ConvertToFilename = "[" & SpaceToUnderscore(art) & "]-" & track _
                                        & SpaceToUnderscore(Left(tit, dum)) & ".mp3"
                Else
                    ConvertToFilename = track & "[" & SpaceToUnderscore(art) & "]-" _
                                        & SpaceToUnderscore(Left(tit, dum)) & ".mp3"
                End If
            End If
        Else
            If opt.TrackNo = 0 Then
                ConvertToFilename = "[" & SpaceToUnderscore(art) & "]-" _
                    & SpaceToUnderscore(tit) & ".mp3"
            ElseIf opt.TrackNo = 1 Then
                ConvertToFilename = "[" & SpaceToUnderscore(art) & "]-" _
                    & track & SpaceToUnderscore(tit) & ".mp3"
            Else
                ConvertToFilename = track & "[" & SpaceToUnderscore(art) & "]-" _
                    & SpaceToUnderscore(tit) & ".mp3"
            End If
        End If
    ElseIf opt.ConvertToSpace Then
        If Len(art) + Len(tit) + 7 + offset > 60 Then
            dum = 60 - (Len(art) + 7 + offset)
            If dum < 0 Then
                dum = 60 - (Len(tit) + 7 + offset)
                If opt.TrackNo = 0 Then
                    ConvertToFilename = SpaceToUnderscore(Left(art, dum)) & " - " _
                                        & SpaceToUnderscore(tit) & ".mp3"
                ElseIf opt.TrackNo = 1 Then
                    ConvertToFilename = SpaceToUnderscore(Left(art, dum)) & " - " _
                                        & track & SpaceToUnderscore(tit) & ".mp3"
                Else
                    ConvertToFilename = track & SpaceToUnderscore(Left(art, dum)) & " - " _
                                        & SpaceToUnderscore(tit) & ".mp3"
                End If
            Else
                If opt.TrackNo = 0 Then
                    ConvertToFilename = SpaceToUnderscore(art) & " - " _
                                        & SpaceToUnderscore(Left(tit, dum)) & ".mp3"
                ElseIf opt.TrackNo = 1 Then
                    ConvertToFilename = SpaceToUnderscore(art) & " - " & track _
                                        & SpaceToUnderscore(Left(tit, dum)) & ".mp3"
                Else
                    ConvertToFilename = track & SpaceToUnderscore(art) & " - " _
                                        & SpaceToUnderscore(Left(tit, dum)) & ".mp3"
                End If
            End If
        Else
            If opt.TrackNo = 0 Then
                ConvertToFilename = SpaceToUnderscore(art) & " - " _
                    & SpaceToUnderscore(tit) & ".mp3"
            ElseIf opt.TrackNo = 1 Then
                ConvertToFilename = SpaceToUnderscore(art) & " - " _
                    & track & SpaceToUnderscore(tit) & ".mp3"
            Else
                ConvertToFilename = track & SpaceToUnderscore(art) & " - " _
                    & SpaceToUnderscore(tit) & ".mp3"
            End If
        End If
    ElseIf opt.ConvertToSquareSpace Then
        If Len(art) + Len(tit) + 7 + offset > 60 Then
            dum = 60 - (Len(art) + 7 + offset)
            If dum < 0 Then
                dum = 60 - (Len(tit) + 7 + offset)
                If opt.TrackNo = 0 Then
                    ConvertToFilename = "[ " & SpaceToUnderscore(Left(art, dum)) & " ] " _
                                        & SpaceToUnderscore(tit) & ".mp3"
                ElseIf opt.TrackNo = 1 Then
                    ConvertToFilename = "[ " & SpaceToUnderscore(Left(art, dum)) & " ] " _
                                        & track & " " & SpaceToUnderscore(tit) & ".mp3"
                Else
                    ConvertToFilename = track & " [ " & SpaceToUnderscore(Left(art, dum)) & " ] " _
                                        & SpaceToUnderscore(tit) & ".mp3"
                End If
            Else
                If opt.TrackNo = 0 Then
                    ConvertToFilename = "[ " & SpaceToUnderscore(art) & " ] " _
                                        & SpaceToUnderscore(Left(tit, dum)) & ".mp3"
                ElseIf opt.TrackNo = 1 Then
                    ConvertToFilename = "[ " & SpaceToUnderscore(art) & " ] " & track _
                                        & " " & SpaceToUnderscore(Left(tit, dum)) & ".mp3"
                Else
                    ConvertToFilename = track & " [ " & SpaceToUnderscore(art) & " ] " _
                                        & SpaceToUnderscore(Left(tit, dum)) & ".mp3"
                End If
            End If
        Else
            If opt.TrackNo = 0 Then
                ConvertToFilename = "[ " & SpaceToUnderscore(art) & " ] " _
                    & SpaceToUnderscore(tit) & ".mp3"
            ElseIf opt.TrackNo = 1 Then
                ConvertToFilename = "[ " & SpaceToUnderscore(art) & " ] " _
                    & track & " " & SpaceToUnderscore(tit) & ".mp3"
            Else
                ConvertToFilename = track & " [ " & SpaceToUnderscore(art) & " ] " _
                    & SpaceToUnderscore(tit) & ".mp3"
            End If
        End If
    End If
End Function

Private Sub clearId3()
    Dim Options As New COptions
    
    Options.readOptions
    id3Title = String(30, " ")
    id3Artist = String(30, " ")
    id3Album = String(30, " ")
    id3Comment = String(30, " ")
    id3Year = String(30, " ")
    id3Genre = Options.defaultGenre
    mp3Type = -1
    mp3Sample = -1
    mp3Bitrate = -1
    mp3Length = -1
    mp3Mono = -1
    
End Sub

Private Sub createNewTag(ByVal num As Integer)
    Put #num, LOF(num) + 1, "TAG"
End Sub

Public Sub Reset()
    clearId3
End Sub

Public Function killBeginningSpace(ByVal ins As String) As String
    'assumption: no space after text
    Dim pos As Integer
    pos = 0
    Do While InStr(pos + 1, ins, " ") > 0
        pos = InStr(pos + 1, ins, " ")
    Loop
    killBeginningSpace = Mid(ins, pos + 1)
End Function

Public Function killSpace(ByVal ins As String) As String
    Dim pos As Integer
    
    pos = Len(ins)
    Do While (pos > 0)
        If Mid(ins, pos, 1) <> " " And Mid(ins, pos, 1) <> Chr(0) Then
            Exit Do
        End If
        pos = pos - 1
    Loop
    If pos > 0 Then
        killSpace = Left(ins, pos)
    Else
        killSpace = ""
    End If
    
End Function

Private Function killUnderscore(ByVal ins As String) As String
    Dim pos As Integer
    Dim work As String
    
    work = ins
    For pos = 1 To Len(ins)
        If Mid(work, pos, 1) = "_" Then
            work = Left(work, pos - 1) & " " & Mid(work, pos + 1)
        End If
    Next pos
    
    killUnderscore = work
End Function

Private Function SpaceToUnderscore(ByVal ins As String) As String
    Dim pos As Integer
    Dim work As String
    Dim opt As New COptions
    
    opt.readOptions
    
    work = ins
    For pos = 1 To Len(ins)
        If Mid(work, pos, 1) = "?" Or Mid(work, pos, 1) = "*" Or Mid(work, pos, 1) = "/" Or Mid(work, pos, 1) = "\" Or Mid(work, pos, 1) = ":" Or Mid(work, pos, 1) = ";" Then
            work = Left(work, pos - 1) & " " & Mid(work, pos + 1)
        End If
        If Mid(work, pos, 1) = " " And opt.ConvertUnderscore Then
            work = Left(work, pos - 1) & "_" & Mid(work, pos + 1)
        End If
    Next pos
    
    SpaceToUnderscore = work
End Function

Private Function cutTag(ByVal ins As String, ByVal length As Byte) As String
    Dim opt As New COptions
    
    If Len(ins) <= length Then
        cutTag = ins
    Else
        opt.readOptions
        If opt.FillUp = "" Then
            cutTag = Left(ins, length)
        Else
            cutTag = Left(ins, length - Len(opt.FillUp)) & opt.FillUp
        End If
    End If
    
End Function

'finds the first mp3 frame in file denoted by handle after file position start
'Returns: offset to first byte of frame (this is always 0xff)
'         -1 if no synchronization could be found
Private Function findSync(ByVal handle As Integer, ByVal start As Integer) As Integer
    Dim count As Integer
    Dim b1 As Byte
    Dim b2 As Byte
    
    count = start
    b1 = b2 = 0
    
    Get #handle, count, b1
    While (b2 <> 255 Or b1 < 240) And Not EOF(handle)
        b2 = b1
        count = count + 1
        Get #handle, count, b1
    Wend
    
    'after this, count is one too high
    count = count - 1
    
    If b2 = 255 And b1 > 239 Then
        findSync = count
    Else
        findSync = -1
    End If
    
End Function

Private Function readType(ByVal num As Integer, ByVal offset As Integer)
    Dim b As Byte

    Get #num, 1 + offset, b
    b = (b And 24) / 8
    Select Case b
    Case 0
        mp3Type = 2.5
    Case 2
        mp3Type = 2#
    Case 3
        mp3Type = 1#
    Case Else
        mp3Type = 0#
        'illegal format
    End Select
    
    readType = mp3Type
End Function

Private Function readBitrate(ByVal num As Integer, ByVal offset As Integer, _
                             ByVal mp3Type As Integer, opt As COptions, ByVal pn As String)
    Dim b As Byte
    Dim mp3Bitrate As Integer
        
    Get #num, 2 + offset, b
    b = (b And 240) / 16
    If mp3Type = 1 Then
        Select Case b
        Case 1
            mp3Bitrate = 32
        Case 2
            mp3Bitrate = 40
        Case 3
            mp3Bitrate = 48
        Case 4
            mp3Bitrate = 56
        Case 5
            mp3Bitrate = 64
        Case 6
            mp3Bitrate = 80
        Case 7
            mp3Bitrate = 96
        Case 8
            mp3Bitrate = 112
        Case 9
            mp3Bitrate = 128
        Case 10
            mp3Bitrate = 160
        Case 11
            mp3Bitrate = 192
        Case 12
            mp3Bitrate = 224
        Case 13
            mp3Bitrate = 256
        Case 14
            mp3Bitrate = 320
        Case Else
            If opt.ShowMp3Error Then
                MsgBox "File " & pn & " has illegal bitrate.", , "Reading mp3 file"
            End If
            mp3Bitrate = -1
        End Select
    ElseIf mp3Type = 2 Then
        Select Case b
        Case 2
            mp3Bitrate = 16
        Case 3
            mp3Bitrate = 24
        Case 4
            mp3Bitrate = 32
        Case 7
            mp3Bitrate = 56
        Case 8
            mp3Bitrate = 64
        Case Else
            If opt.ShowMp3Error Then
                MsgBox "File " & pn & " has illegal bitrate.", , "Reading mp3 file"
            End If
            mp3Bitrate = -1
        End Select
    ElseIf mp3Type = 2.5 Then
        Select Case b
        Case 1
            mp3Bitrate = 8
        Case 2
            mp3Bitrate = 16
        Case Else
            If opt.ShowMp3Error Then
                MsgBox "File " & pn & " has illegal bitrate.", , "Reading mp3 file"
            End If
            mp3Bitrate = -1
        End Select
    End If
    
    readBitrate = mp3Bitrate
End Function

Private Function readSamplerate(ByVal num As Integer, ByVal offset As Integer, _
                                ByVal mp3Type As Integer, opt As COptions, _
                                ByVal pn As String) As Single
    Dim b As Byte
    Dim mp3Sample As Integer
    
    Get #num, 2 + offset, b
    b = (b And 12) / 4
    If mp3Type = 1 Then
        Select Case b
        Case 0
            mp3Sample = 44.1
        Case 1
            mp3Sample = 48#
        Case 2
            mp3Sample = 32#
        Case Else
            If opt.ShowMp3Error Then
                MsgBox "File " & pn & " has illegal sampling frequency.", , "Reading mp3 file"
            End If
            mp3Sample = -1#
        End Select
    ElseIf mp3Type = 2 Then
        Select Case b
        Case 0
            mp3Sample = 22.05
        Case 1
            mp3Sample = 24
        Case 2
            mp3Sample = 16
        Case Else
            If opt.ShowMp3Error Then
                MsgBox "File " & pn & " has illegal sampling frequency.", , "Reading mp3 file"
            End If
            mp3Sample = -1#
        End Select
    ElseIf mp3Type = 2.5 Then
        Select Case b
        Case 0
            mp3Sample = 11.025
        Case 2
            mp3Sample = 8
        Case Else
            If opt.ShowMp3Error Then
                MsgBox "File " & pn & " has illegal sampling frequency.", , "Reading mp3 file"
            End If
            mp3Sample = -1#
        End Select
    End If
    
    readSamplerate = mp3Sample

End Function

Private Function readMono(ByVal num As Integer, ByVal offset As Integer, _
                          ByVal mp3Type As Integer, opt As COptions, _
                          ByVal pn As String) As Integer
    Dim b As Byte

    Get #num, 3 + offset, b
    b = (b And 240) / 64
    Select Case b
    Case 0
        readMono = 1
    Case 1
        readMono = 2
    Case 2
        readMono = 3
    Case 3
        readMono = 0
    Case Else
        If opt.ShowMp3Error Then
            MsgBox "File " & pn & " has illegal mono/stereo info.", vbOKOnly, "Reading mp3 file"
        End If
        readMono = -1
    End Select
End Function

Private Function checkVBR(ByVal num As Integer, ByVal offset As Integer, _
                          ByVal mp3Type As Integer, ByVal mp3Mono As Integer) _
                          As Boolean
    Dim xing As String * 4
    Dim start As Integer
    Dim flags As Currency
    Dim frames As Currency
    Dim bytes As Currency
    Dim scle As Currency
    Dim bitrate As Integer
    Dim length As Integer
    
    If mp3Type = 1 Then
        If mp3Mono <> 0 Then
            start = 36
        Else
            start = 21
        End If
    Else
        If mp3Mono <> 0 Then
            start = 21
        Else
            start = 13
        End If
    End If
    
    Get #num, offset + start, xing
    If xing = "Xing" Then
        checkVBR = True
    Else
        checkVBR = False
    End If
    
End Function

Private Function read4Bytes(ByVal num As Integer, ByVal pos As Integer) As Currency
    Dim calc As Currency
    Dim b As Byte
    Dim x As Currency
    
    calc = 0
    Get #num, pos + 3, b
    x = b
    If x < 0 Then x = x + 256
    calc = x
    
    Get #num, pos + 2, b
    x = b
    If x < 0 Then x = x + 256
    calc = calc + x * 256
    
    Get #num, pos + 1, b
    x = b
    If x < 0 Then x = x + 256
    calc = calc + x * 256 * 256
    
    Get #num, pos, b
    x = b
    If x < 0 Then x = x + 256
    calc = calc + x * 256 * 256 * 256 * 256
    
    read4Bytes = calc
End Function


Private Function readVBRFlags(ByVal num As Integer, ByVal offset As Integer, _
                              ByVal mp3Type As Integer, ByVal mp3Mono As Integer) _
                              As Currency
    Dim start As Integer
    
    If mp3Type = 1 Then
        If mp3Mono <> 0 Then
            start = 36
        Else
            start = 21
        End If
    Else
        If mp3Mono <> 0 Then
            start = 21
        Else
            start = 13
        End If
    End If
    
    readVBRFlags = read4Bytes(num, offset + start + 4)

End Function

Private Function readVBRFrames(ByVal num As Integer, ByVal offset As Integer, _
                              ByVal mp3Type As Integer, ByVal mp3Mono As Integer) _
                              As Currency
    Dim start As Integer
    
    If mp3Type = 1 Then
        If mp3Mono <> 0 Then
            start = 36
        Else
            start = 21
        End If
    Else
        If mp3Mono <> 0 Then
            start = 21
        Else
            start = 13
        End If
    End If
    
    readVBRFrames = read4Bytes(num, offset + start + 8)

End Function

Private Function readVBRBytes(ByVal num As Integer, ByVal offset As Integer, _
                              ByVal mp3Type As Integer, ByVal mp3Mono As Integer) _
                              As Currency
    Dim start As Integer
    
    If mp3Type = 1 Then
        If mp3Mono <> 0 Then
            start = 36
        Else
            start = 21
        End If
    Else
        If mp3Mono <> 0 Then
            start = 21
        Else
            start = 13
        End If
    End If
    
    readVBRBytes = read4Bytes(num, offset + start + 12)

End Function

'replaces spaces at end of string with \0
Private Function spaceToNull(ByVal s As String) As String
    Dim i As Integer
    Dim out As String
    
    out = s
    i = Len(out)
    While i > 1 And Mid(out, i, 1) = " "
        Mid(out, i, 1) = Chr(0)
        i = i - 1
    Wend
    
    If Mid(out, 2, 1) = Chr(0) And Mid(out, 1, 1) = " " Then
        Mid(out, 1, 1) = Chr(0)
    End If
    
    spaceToNull = out
End Function
